<?php
namespace Backend\Controller;
use Backend\Controller\BackendController;
use Backend\Model\FrontendMenuModel as FrontendMenu;
/**
 * 前台菜单管理
 */
class FrontendMenuController extends BackendController{
	/**
	 * 菜单列表
	 */
	public function index(){
		$FrontendMenu = new FrontendMenu();
		$data = $FrontendMenu->getTreeData('tree',array('order_number','id'));
		$this->assign('data',$data);
		$this->display();
	}

	/**
	 * 添加菜单
	 */
	public function add(){
		$FrontendMenu = new FrontendMenu();
		$data = I('post.');
		unset($data['id']);
		$FrontendMenu->addData($data);
		$this->success('添加成功',U('FrontendMenu/index'));
	}

	/**
	 * 修改菜单
	 */
	public function edit(){
		$FrontendMenu = new FrontendMenu();
		$data = I('post.');
		$map = array('id'=>$data['id']);
		$FrontendMenu->editData($map,$data);
		$this->success('修改成功',U('FrontendMenu/index'));
	}

	/**
	 * 删除菜单
	 */
	public function delete(){
		$FrontendMenu = new FrontendMenu();
		$id = I('get.id');
		$map = array('id'=>$id);
		$result = $FrontendMenu->deleteData($map);
		if($result){
			$this->success('删除成功',U('FrontendMenu/index'));
		}else{
			$this->error('请先删除子菜单');
		}
	}

	/**
	 * 菜单排序
	 */
	public function order(){
		$FrontendMenu = new FrontendMenu();
		$data = I('post.');
		$FrontendMenu->orderData($data);
		$this->success('排序成功',U('FrontendMenu/index'));
	}

	/**
	 * 菜单显示
	 */
	public function isdisplay(){
		$FrontendMenu = new FrontendMenu();
		$data = request();
		$result = $FrontendMenu->displayData($data);
		if($result !== false){
			$this->success('修改成功',U('FrontendMenu/index'),true);
		}else{
			$this->error('修改失败',U('FrontendMenu/index'),true);
		}
	}
}
