<?php
namespace Backend\Controller;
use Backend\Controller\BackendController;
use Backend\Model\ProductTypeModel as ProductType;

/**
 * | 产品分类管理
 * |@author: Guopeng
 * |@时间: 2017年9月14日 下午5:02:01
 */
class ProductTypeController extends BackendController{
	/**
	 * | 产品分类列表页
	 * | @时间: 2017年9月14日 下午5:03:32
	 * | @author: Guopeng
	 */
	public function index(){
		$product_type = new ProductType();
		$data = $product_type->getTreeData('tree','order_num,id');
		$this->assign('data',$data);
		$this->display();
	}

	/**
	 * 添加产品分类
	 */
	public function add(){
		$product_type = new ProductType();
		$data = I('post.');
		unset($data['id']);
		$product_type->addData($data);
		$this->success('添加成功',U('ProductType/index'));
	}

	/**
	 * 修改产品分类
	 */
	public function edit(){
		$product_type = new ProductType();
		$data = I('post.');
		$map = array('id'=>$data['id']);
		$product_type->editData($map,$data);
		$this->success('修改成功',U('ProductType/index'));
	}

	/**
	 * 删除产品分类
	 */
	public function delete(){
		$product_type = new ProductType();
		$id = I('get.id');
		$map = array('id'=>$id);
		$result = $product_type->deleteData($map);
		if($result){
			$this->success('删除成功',U('ProductType/index'));
		}else{
			$this->error('请先删除子菜单');
		}
	}

	/**
	 * 产品分类排序
	 */
	public function order(){
		$product_type = new ProductType();
		$data = I('post.');
		$product_type->orderData($data);
		$this->success('排序成功',U('ProductType/index'));
	}

	/**
	 * 产品分类显示
	 */
	public function isdisplay(){
		$product_type = new ProductType();
		$data = request();
		$product_type->displayData($data);
		$this->success('修改成功',U('ProductType/index'),true);
	}
}