<?php
namespace Backend\Model;

use Backend\Model\BackendModel;

/**
 * 常见问题分类类
 * @author: Guopeng
 * @时间: 2017年10月25日11:06:18
 * @version: 1.0
 */
class CommonProblemTypeModel extends BackendModel{
	//关联的表名
	protected $trueTableName = 'agent_common_problem_type';
	//新增是允许写入的字段
	protected $insertFields = ['name','create_time','update_time','beizhu'];
	//更新是允许更新的字段
	protected $updateFields = ['name','update_time','beizhu'];
	
	//搜索条件字段
	public $searchable = [
		'key' => ['name' => '分类名']
	];
	
	//排序字段
	public $sortable = [
		'id' => ['display_name' => '编号','sortable' => true],
		'name' => ['display_name' => '分类名称','sortable' => false],
		'create_time' => ['display_name' => '创建时间','sortable' => true],
		'update_time' => ['display_name' => '修改时间','sortable' => false],
		'beizhu' => ['display_name' => '备注','sortable' => false]
	];

	/**
	 * 获取搜索条件所需要的数据
	 * 可以实现getFillData方法，
	 * 将一些需要的数据复给$this->fill_data
	 * 例如本类的getFillData()方法
	 * @时间: 2017年10月25日10:59:23
	 * @author: Guopeng
	 * @param array $fill_data
	 * @return null
	 */
	public function getSearchable($fill_data = []){
		if(empty($fill_data)){
			return $this->fillSearchable($this->fillData);
		}else{
			return $this->fillSearchable($fill_data);
		}
	}
	
	/**
	 * 获取搜索条件需要的数据
	 * @时间: 2017年10月25日10:59:23
	 * @author: Guopeng
	 * @return $this
	 */
	public function getFillData(){
		return $this;
	}

	/**
	 * 获取所有的常见问题分类
	 * @时间: 2017年10月25日10:59:23
	 * @author: Guopeng
	 * @param string $field
	 * @param array $where
	 * @param string $order
	 * @return array
	 */
	public function getType($field = '*',$type = 0,$order = '') {
		$where["type"] = $type;
		$res = parent::getAll( $field, $where, $order);
		$_res = [];
		foreach ($res as $k => $v) {
			$_res[$v['k']] = $v['v'];
		}
		return $_res;
	}

	/**********************************新增更新回调/开始***********************************/
	/**
	 * 插入数据之前的回调
	 * @时间: 2017年10月25日10:59:23
	 * @author: Guopeng
	 * @param $data
	 * @param $options
	 */
	protected function _before_insert(&$data,$options){
		//添加创建时间默认值
		$data['create_time'] = date('Y-m-d H:i:s',time());
		$data['update_time'] = date('Y-m-d H:i:s',time());
	}

	/**
	 * 插入成功后的回调
	 * @时间: 2017年10月25日10:59:23
	 * @author: Guopeng
	 * @param $data
	 * @param $options
	 */
	protected function _after_insert($data,$options){
	}
	
	/**
	 * 更新数据之前做的操作
	 * @时间: 2017年10月25日10:59:23
	 * @author: Guopeng
	 * @param $data
	 * @param $options
	 */
	protected function _before_update(&$data,$options){
		$data['update_time'] = date('Y-m-d H:i:s',time());
	}

	/**
	 * 更新之后做的操作
	 * @时间: 2017年10月25日10:59:23
	 * @author: Guopeng
	 * @param $data
	 * @param $options
	 */
	protected function _after_update($data,$options){
	}
	
}
