<?php
namespace Backend\Model;
use Backend\Model\BackendModel;
use Common\Aide\InfinitenessAide;

/**
 * -------------------------------------------------------
 * | 产品分类模型类
 * | @author: duanbin
 * | @时间: 2016年10月9日 下午3:34:41
 * | @version: 1.0
 * -------------------------------------------------------
 */
class ProductTypeModel extends BackendModel{
	
	//关联的表名
	protected $trueTableName = 'agent_product_type';

	/**
	 * 删除数据
	 * @param	array	$map	where语句数组形式
	 * @return	boolean			操作是否成功
	 */
	public function deleteData($map){
		$count=$this
			->where(array('parent_id'=>$map['id']))
			->count();
		if($count!=0){
			return false;
		}
		$this->where(array($map))->delete();
		return true;
	}

	/**
	 * 获取全部产品分类
	 * @param  string $type tree获取树形结构 level获取层级结构
	 * @return array       	结构数据
	 */
	public function getTreeData($type='tree',$order=''){
		// 判断是否需要排序
		if(empty($order)){
			$data = $this->where(["_string"=>"FIND_IN_SET ('2',product_stage)"])->select();
		}else{
			$data = $this->where(["_string"=>"FIND_IN_SET ('2',product_stage)"])->order($order)->select();
		}
		// 获取树形或者结构数据
		if($type=='tree'){
			$data=InfinitenessAide::tree($data,'type_name','id','parent_id');
		}elseif($type=="level"){
			$data=InfinitenessAide::channelLevel($data,0,'&nbsp;','id');
		}
		return $data;
	}

	public function displayData($data){
		$id = $data["id"];
		$type = $data["type"];
		return $this->where(["id"=>$id])->save(["display"=>$type]);
	}
}
