<?php
namespace Common\Respository;
use Common\Respository\BaseRespository;

/**
 * 问题分类仓储类
 * 可选择实现orderExtra()，whereExtra()，fieldsExtra()方法，
 * 为了有连表的情况出现，额外设置别名
 * @author: Guopeng
 * @时间: 2017年10月25日11:06:44
 * @version: 1.0
 */
class ProblemTypeRespository extends BaseRespository{
	/**
	 * 扩充查询字段，在连表的情况下有别名使用
	 * @时间: 2017年10月25日10:59:23
	 * @author: Guopeng
	 * @param $fields
	 * @return mixed
	 */
	protected function fieldsExtra($fields){
		return $fields;
	}
	
	/**
	 * 返回一个join数组
	 * 连表查询时，请实现此方法
	 * @时间: 2017年10月25日10:59:23
	 * @author: Guopeng
	 * @return array
	 */
	protected function joinsExtra(){
		return [];
	}
	
	/**
	 * 额外的扩充条件，这里要增加一项
	 * product_id值得条件
	 * @时间: 2017年10月25日10:59:23
	 * @author: Guopeng
	 * @param $where
	 * @param $request
	 * @return mixed
	 */
	protected function whereExtra($where,$request){
		return $where;
	}

	/**
	 * 额外的扩充排序，这里要增加一项
	 * product_id值得条件
	 * @时间: 2017年10月25日10:59:23
	 * @author: Guopeng
	 * @param $order
	 * @param $request
	 * @return string
	 */
	public function orderExtra($order,$request){
		//增加默认排序规则
		if(empty($order)){
			//到期时间倒序
			$order = 'create_time DESC';
		}
		return $order;
	}
	
}