<?php
namespace Frontend\Controller;
use Frontend\Controller\FrontendController;
/**
* 会员中心
* @date: 2016年10月25日 上午10:23:41
* @author: Lyubo
*/
class MemberController extends FrontendController{

    /**
     * 判断用户是否登陆
     * @date: 2016年10月25日 下午3:25:56
     * @author : Lyubo
     */
    public function _initialize(){
        parent::_initialize();
        if (! session('?user_id')) {
            redirect(U('Login/login'),0,'');
            die();
        }
    }

    public function index()
    {
        $member = new \Frontend\Model\MemberModel();
        $member_info = $member->get_member_money();
        $article = new \Frontend\Model\ArticleModel();
        $notices = $article->home_news(array("type"=>3));
        $this->assign([
            "notices"=>$notices,
            "member_info"=>$member_info
        ]);
        $this->display();
    }

    /**
    * 获取会员信息
    * @date: 2016年11月1日 下午3:22:12
    * @author: Lyubo
    * @param: $info
    */
    public function memberinfo(){
        $member = new \Frontend\Model\MemberModel();
        $where = $member->conver_par();
        $member_info = $member->get_member_info($where);
        if(IS_POST){
            $result = $member->member_modify_info($where);
            if($result !== false){
                session('user_name',I('post.user_name'));
                $this->success("修改信息成功",U("member/memberinfo"));
            }else{
                $msg = $member->getError();
                $msg = "修改信息失败-".$msg;
                $this->error($msg,U("member/memberinfo"));
            }
        }else {
            $email = $member_info["user_mail"];
            if(!empty($email)){
                $arr = explode('@',$email);
                $arr[0] = substr_replace($arr[0],'****',4);
                $email = $arr[0]."@".$arr[1];
            }else{
				$email = "未绑定邮箱";
			}
            $this->assign(["member_info"=>$member_info,"email"=>$email]);
            $this->display();
        }
    }

    /**
    * 安全中心
    * @date: 2016年11月1日 下午3:45:59
    * @author: Lyubo
    */
    public function membersafe(){
        $member = new \Frontend\Model\MemberModel();
        $where = $member->conver_par();
        $member_info = $member->get_member_info($where);
		$email = $member_info["user_mail"];
		if(!empty($email)){
			$arr = explode('@',$email);
			$arr[0] = substr_replace($arr[0],'****',4);
			$email = $arr[0]."@".$arr[1];
		}
        $this->assign(["email" => $email,"user_name"=>$member_info["user_name"]]);
        $this->display();
    }
    
    /**
    * 修改会员密码（原密码修改）
    * @date: 2016年11月1日 下午4:38:55
    * @author: Lyubo
    * @return boolean
    */
    public function memeber_modify_pass()
    {
        $member = new \Frontend\Model\MemberModel();
        $data = $member->conver_par();
        $result = $member->member_modify_pass($data);
        if($result !== false){
//            session('user_id',null);
//            session('user_name',null);
//            session('login_name',null);
            $msg = "密码修改成功！";
            $this->success($msg,"",true);
        }else{
            $msg = $member->getError();
            $this->error($msg,"",true);
        }
    }

    /**
     * 业务数获取
     * @date: 2016年12月8日 上午10:09:49
     * @author: Guopeng
     */
    public function state_count(){
        $user_id = intval(session("user_id"));
        $member = new \Frontend\Model\MemberModel();
        $sum = $member->ywcount($user_id);
        $date["status"] = 'ok';
        $date["sum"] = $sum;
        return $this->ajaxReturn($date);
    }

    /**
     * 发送验证邮件
     * @author: Guopeng
     * return: ajax\json
     */
    public function memeber_sendMail(){
        if(IS_POST){
            $member = new \Frontend\Model\MemberModel();
            $result = $member->sendMail();
            if($result !== false){
                $msg = "验证码发送成功，请在30分钟内使用！";
                $this->success($msg,"",true);
            }else{
                $msg = $member->getError();
                $this->error($msg,"",true);
            }
        }else{
            $this->_empty();
        }
    }

    /**
     * 修改绑定邮箱
     * @date: 2017年7月5日 上午11:26:55
     * @author: Guopeng
     */
    public function member_mail(){
        if(IS_POST){
            $member = new \Frontend\Model\MemberModel();
            $result = $member->member_modify_mail();
            if($result !== false){
                $msg = "邮箱修改成功！";
                $this->success($msg,"",true);
            }else{
                $msg = $member->getError();
                $this->error($msg,"",true);
            }
        }else{
			$member = new \Frontend\Model\MemberModel();
			$where = $member->conver_par();
			$member_info = $member->get_member_info($where);
			$email = $member_info["user_mail"];
			if(!empty($email)){
				$arr = explode('@',$email);
				$arr[0] = substr_replace($arr[0],'****',4);
				$email = $arr[0]."@".$arr[1];
			}
			$this->assign(["email" => $email]);
            $this->display();
        }
    }
}